## ponyprog 3.0.2+ds

=== CMakeLists.txt ===
PROJECT(ponyprog)

# Configure CMake ...
CMAKE_MINIMUM_REQUIRED(VERSION 2.8 FATAL_ERROR)
# CMAKE_POLICY(SET CMP0003 OLD)
# CMAKE_POLICY(SET CMP0015 OLD)

# set the Qt version to 4 or 5
OPTION (USE_QT5 "Using of Qt5 version for compiling" ON)

IF(${USE_QT5})
    SET(USE_QT_VERSION 5)
ELSE(${USE_QT5})
    SET(USE_QT_VERSION 4)
ENDIF(${USE_QT5})

# # SET(FILES_TO_TRANSLATE)
IF(WIN32)
    IF(MSVC)
        SET (CMAKE_PREFIX_PATH "${CMAKE_PREFIX_PATH}:${QTDIR}\\msvc2015\\")
    ENDIF()

    IF(MinGW)
        SET (CMAKE_PREFIX_PATH "${CMAKE_PREFIX_PATH}:${QTDIR}\\mingw53_32\\")
    ENDIF()
ENDIF()

#disable -rdynamic
# SET(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS "")
# SET(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS "")


# FILE (GLOB TRANSLATIONS_FILES ${CMAKE_CURRENT_SOURCE_DIR}/translations/*.ts)

# OPTION (UPDATE_TRANSLATIONS "Update source translation ${CMAKE_CURRENT_SOURCE_DIR}/translations/*.ts" OFF)


MESSAGE(STATUS "Qt version for compiling: " ${USE_QT_VERSION})

OPTION (USE_DEBUGGER "Include in binary file debug information" OFF)

OPTION (USE_PROFILER "Include in binary file profiling information" OFF)


IF(${USE_DEBUGGER})
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS_DEBUG} -Wall")
ELSE()
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS_RELEASE} -Wall")
ENDIF()

MESSAGE(STATUS "CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS}")

INCLUDE(CheckIncludeFile)
INCLUDE(CheckIncludeFileCXX)
INCLUDE(TestCXXAcceptsFlag)
INCLUDE(CheckCXXCompilerFlag)


SET(TARGET_NAME ponyprog )
SET(CMAKE_HELPERS_BINARY_DIR ${PROJECT_SOURCE_DIR}/cmake)
SET(CMAKE_HELPERS_SOURCE_DIR ${PROJECT_SOURCE_DIR}/cmake)
LIST(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")



INCLUDE(OutOfSourceBuild) # Disallow in-source builds

INCLUDE(GenerateDEF) # Convenience macro for linking Win32 DLLs using MSVC
INCLUDE(Dependencies)


SET(CURRENT_BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR})


# Set the PonyProg version
# this for generating of version file from HISTORY file
# the idea is to descript all changes in this file, the ne changes are in the top of file
FILE(READ "HISTORY" DESCRIBE_STRING)
STRING(REGEX MATCH "([0-9]+\\.[0-9]+\\.[0-9]+)" APP_VERSION "${DESCRIBE_STRING}" )

MESSAGE(STATUS "Version info: ${APP_VERSION}") 
SET(VERSION ${APP_VERSION})

# 
# SET(APP_VERSION "3.0.0")
SET(APP_AUTHOR "Claudio Lanconelli")
SET(APP_EMAIL "PonyProg2000@gmail.com")
SET(APP_NAME "PonyProg")

IF(WIN32)
  EXECUTE_PROCESS (
    COMMAND "cmd" " /c date /t"
    OUTPUT_VARIABLE APP_BUILD_DATE
    OUTPUT_STRIP_TRAILING_WHITESPACE)
ELSE()
  EXECUTE_PROCESS (
    COMMAND date +"%d.%m.%Y"
    OUTPUT_VARIABLE APP_BUILD_DATE
    OUTPUT_STRIP_TRAILING_WHITESPACE)
    STRING(REGEX REPLACE "\"" "" APP_BUILD_DATE ${APP_BUILD_DATE})
ENDIF()

MESSAGE(STATUS "Version build date: ${APP_BUILD_DATE}")

# 
SET(PONYPROG_PACKAGE ponyprog)
SET(PONYPROG_HOST ${CMAKE_SYSTEM} ${CMAKE_SYSTEM_PROCESSOR})
SET(PONYPROG_COPYRIGHT "Copyright (c) 1997-2019   ${APP_AUTHOR}, All Rights Reserved.")
SET(PONYPROG_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})

# Setup high-level build options
# IF(MSVC)
#   SET(PONYPROG_ENABLE_SYMBOL_VISIBILITY_DEFAULT ON)
# ELSE(MSVC)
#   SET(PONYPROG_ENABLE_SYMBOL_VISIBILITY_DEFAULT OFF)
# ENDIF(MSVC)

IF (CMAKE_COMPILER_IS_GNUCC AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.7)
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x -fno-exceptions -fno-rtti")
ELSE()
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fno-exceptions -fno-rtti")
ENDIF()


# options for gprof 
IF(${USE_PROFILER})
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pg")
  SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pg")
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -pg")
  # after execution of program: gprof ./build/ponyprog
  # and get the information from gprof.txt file
  MESSAGE(STATUS "Compile with profiling information")
ELSE()
  MESSAGE(STATUS "Compile without profiling information")
ENDIF()



IF(${USE_QT_VERSION} MATCHES "4")
    SET(HAVE_QT_PRINTSUPPORT true)
    FIND_PACKAGE(Qt4 COMPONENTS QtCore QtGui REQUIRED)

    IF(NOT QT4_FOUND)
        MESSAGE(FATAL_ERROR "Qt4 could not be found. "
        "If it's INSTALLed in a non-standard location, specify the path to qmake in QT_QMAKE_EXECUTABLE. "
        "You can do it in interactive mode (ccmake instead of cmake) or using -DVAR=VAL syntax.")
    ENDIF()
ELSE()
    FIND_PACKAGE(Qt5 COMPONENTS Core PrintSupport Gui Widgets Multimedia REQUIRED QUIET)

    IF(NOT Qt5Widgets_FOUND)
        MESSAGE(FATAL_ERROR "Qt5 could not be found. "
        "If it's INSTALLed in a non-standard location, specify the path to qmake in QT_QMAKE_EXECUTABLE. "
        "You can do it in interactive mode (ccmake instead of cmake) or using -DVAR=VAL syntax.")
    ENDIF(NOT Qt5Widgets_FOUND)

    IF(NOT Qt5PrintSupport_FOUND)
        MESSAGE(FATAL_ERROR "Qt5 PrintSupport development files are not found. "
        "Qt5PrintSupport development package is to install.")
    ENDIF(NOT Qt5PrintSupport_FOUND)

    IF(NOT Qt5Multimedia_FOUND)
        MESSAGE(FATAL_ERROR "Qt5 Multimedia development files are not found. "
        "Qt5Multimedia development package is to install.")
    ENDIF(NOT Qt5Multimedia_FOUND)
ENDIF()

# for this feature install debhelper or 
SET(PONYPROG_CPACK_PACKAGE_SHLIBDEPS ON)

IF(${USE_QT_VERSION} MATCHES "4")
    INCLUDE_DIRECTORIES(${QT_INCLUDES})
    MESSAGE(STATUS "QT_INCLUDES ${QT_INCLUDES}")
ELSE()
    INCLUDE_DIRECTORIES(${QT_INCLUDES} ${Qt5Widgets_INCLUDE_DIRS}  ${Qt5PrintSupport_INCLUDE_DIRS} ${Qt5Multimedia_INCLUDE_DIRS})

    MESSAGE(STATUS "QT_INCLUDES ${QT_INCLUDES} ${Qt5Widgets_INCLUDE_DIRS} ${Qt5Multimedia_INCLUDE_DIRS}")

    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Widgets_EXECUTABLE_COMPILE_FLAGS} ${Qt5Multimedia_EXECUTABLE_COMPILE_FLAGS} ${Qt5PrintSupport_EXECUTABLE_COMPILE_FLAGS}")
ENDIF()


configure_file (
  "${PROJECT_SOURCE_DIR}/SrcPony/version-cmake.h.in"
  "${PROJECT_SOURCE_DIR}/SrcPony/version.h" )


SET ( OBJECTS_DIR temp )
SET ( MOC_DIR temp )
SET ( UI_HEADERS_DIR temp )
SET ( UI_SOURCES_DIR temp )

ADD_SUBDIRECTORY(qhexedit2/src)
ADD_SUBDIRECTORY(SrcPony)

INCLUDE_DIRECTORIES( ${CMAKE_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/qhexedit2/src/ ${CMAKE_CURRENT_SOURCE_DIR}/SrcPony/ )


IF(${USE_QT_VERSION} MATCHES "4")
#     QT4_ADD_TRANSLATION(APP_TRANSLATIONS ${TRANSLATION})
    QT4_WRAP_CPP(APP_HEADERS_MOC ${HEX_HEADERS} ${PONY_HEADERS} )
    QT4_WRAP_UI(APP_FORMS_HEADERS ${PONY_FORMS} )
    QT4_ADD_RESOURCES(APP_RESOURCES_RCC ${APP_RESOURCES})
ELSE()
#     QT5_ADD_TRANSLATION(APP_TRANSLATIONS ${TRANSLATION})
    QT5_WRAP_CPP(APP_HEADERS_MOC ${HEX_HEADERS} ${PONY_HEADERS} )
    QT5_WRAP_UI(APP_FORMS_HEADERS ${PONY_FORMS} )
    QT5_ADD_RESOURCES(APP_RESOURCES_RCC ${APP_RESOURCES})
ENDIF()


MESSAGE(STATUS "PONY_RESOURCES ${APP_RESOURCES_RCC}")

INCLUDE_DIRECTORIES( ${CMAKE_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

SOURCE_GROUP( "Generated Files" FILES
    ${MOC_FILES_CPP}
    ${APP_FORMS_HEADERS}
    ${APP_RESOURCES_RCC}
)


IF(NOT ${USE_DEBUGGER})
    ADD_DEFINITIONS(${QT_DEFINITIONS} -DQT_NO_DEBUG_OUTPUT -DQT_USE_FAST_CONCATENATION -DQT_USE_FAST_OPERATOR_PLUS)
ENDIF()

IF(${USE_QT_VERSION} MATCHES "4")
    INCLUDE(${QT_USE_FILE})
    ADD_DEFINITIONS(${QT_DEFINITIONS} -DNO_QT3SUPPORT -DDISABLE_QT3SUPPORT -DQT_PROJECT)
ELSE()
    ADD_DEFINITIONS( ${Qt5Widgets_DEFINITIONS} ${Qt5PrintSupport_DEFINITIONS} ${Qt5Multimedia_DEFINITIONS} -DQT_PROJECT )
ENDIF()

IF(WIN32)
    ADD_DEFINITIONS(-DUNICODE -D_UNICODE)
ENDIF()

ADD_EXECUTABLE(${CMAKE_PROJECT_NAME}
    ${APP_SOURCES} 
    ${HEX_SOURCES}
    ${PONY_SOURCES}
    ${APP_HEADERS_MOC} 
    ${APP_FORMS_HEADERS} 
#     ${APP_TRANSLATIONS}
    ${APP_RESOURCES_RCC}
)


IF(${USE_QT_VERSION} MATCHES "4")
  TARGET_LINK_LIBRARIES(${CMAKE_PROJECT_NAME} ${QT_LIBRARIES} )
ELSE()
  TARGET_LINK_LIBRARIES(${CMAKE_PROJECT_NAME} ${QT_LIBRARIES} ${Qt5Widgets_LIBRARIES} ${Qt5Multimedia_LIBRARIES} ${Qt5PrintSupport_LIBRARIES} )
  MESSAGE(STATUS "QT LIBRARIES: ${QT_LIBRARIES} ${Qt5Widgets_LIBRARIES} ${Qt5Multimedia_LIBRARIES} ${Qt5PrintSupport_LIBRARIES} ${Qt5Core_LIBRARIES}")
ENDIF()

ADD_CUSTOM_TARGET (tags
    COMMAND  ctags -R -f tags ${CMAKE_SOURCE_DIR}/SrcPony
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
)


# Setup module enabled/disabled defaults ...
IF(MSVC)
    SET(PONYPROG_BUILD_GLX_MODULE_DEFAULT ON)
    SET(PONYPROG_BUILD_OSX_MODULE_DEFAULT OFF)
    SET(PONYPROG_BUILD_VIRTUAL_OFFSCREEN_MODULE_DEFAULT OFF)
ENDIF(MSVC)

IF(UNIX AND NOT APPLE)
    SET(PONYPROG_BUILD_GLX_MODULE_DEFAULT ON)
    SET(PONYPROG_BUILD_OSX_MODULE_DEFAULT OFF)
    SET(PONYPROG_BUILD_VIRTUAL_OFFSCREEN_MODULE_DEFAULT OFF)
ENDIF(UNIX AND NOT APPLE)

IF(APPLE)
    SET(PONYPROG_BUILD_GLX_MODULE_DEFAULT ON)
    SET(PONYPROG_BUILD_OSX_MODULE_DEFAULT ON)
    SET(PONYPROG_BUILD_VIRTUAL_OFFSCREEN_MODULE_DEFAULT OFF)
ENDIF(APPLE)


OPTION(PONYPROG_ENABLE_SYMBOL_VISIBILITY "Minimize the number of symbols exported from shared libraries." ${PONYPROG_ENABLE_SYMBOL_VISIBILITY_DEFAULT})
MARK_AS_ADVANCED(PONYPROG_ENABLE_SYMBOL_VISIBILITY)

# OPTION(PONYPROG_ENABLE_TESTING "Build the Ponyprog regression test suite." OFF)
# SET(BUILD_TESTING ${PONYPROG_ENABLE_TESTING} CACHE INTERNAL "" FORCE)
# INCLUDE(CTest)
# MARK_AS_ADVANCED(DART_TESTING_TIMEOUT)
# IF(PONYPROG_ENABLE_TESTING)
#     CMAKE_MINIMUM_REQUIRED(VERSION 2.6.1 FATAL_ERROR)
#     CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/CTestCustom.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/CTestCustom.cmake @ONLY)
# ENDIF(PONYPROG_ENABLE_TESTING)

# Capture system configuration
INCLUDE(SystemConfiguration)

# MSVC configuration
IF(MSVC)
    IF(NOT MSVC)
        SET(CMAKE_EXE_LINKER_FLAGS "-Wl,--enable-runtime-pseudo-reloc" CACHE STRING "" FORCE)
        SET(CMAKE_SHARED_LINKER_FLAGS "-Wl,--enable-runtime-pseudo-reloc -Wl,--export-all-symbols" CACHE STRING "" FORCE)
    ENDIF(NOT MSVC)
ENDIF(MSVC)

# Setup output directories ...
SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PONYPROG_BINARY_DIR}/bin)


IF(MSVC)
    SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PONYPROG_BINARY_DIR}/bin)
ELSE(MSVC)
    SET(PONYPROG_LIBDIR lib) # Allows us to handle 64-bit libs if/when it becomes necessary.
    SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PONYPROG_BINARY_DIR}/${PONYPROG_LIBDIR})
ENDIF(MSVC)

# Setup a macro for compiling resources ...
MACRO(PONYPROG_COMPILE_RESOURCE OUTPUT INPUT RESOURCE_PATH)

    SET(INPUT_FILE "${CMAKE_CURRENT_SOURCE_DIR}/${INPUT}")
    SET(OUTPUT_FILE "${CMAKE_CURRENT_BINARY_DIR}/${INPUT}.cpp")
    GET_FILENAME_COMPONENT(OUTPUT_PATH ${OUTPUT_FILE} PATH)

    GET_TARGET_PROPERTY(PONYPROG_RESOURCE_COMPILER ponyprog-resource-compiler LOCATION)

    ADD_CUSTOM_COMMAND(
        DEPENDS ponyprog-resource-compiler
        DEPENDS ${INPUT_FILE}
        COMMAND ${CMAKE_COMMAND} -E make_directory ${OUTPUT_PATH}
        COMMAND ${PONYPROG_RESOURCE_COMPILER} --input ${INPUT_FILE} --path \"<path>${RESOURCE_PATH}</path>\" --output ${OUTPUT_FILE}
        OUTPUT ${OUTPUT_FILE}
        COMMENT "Compiling resource ${INPUT_FILE}"
        )

    LIST(APPEND ${OUTPUT} ${OUTPUT_FILE})

ENDMACRO(PONYPROG_COMPILE_RESOURCE)

# Setup subdirectories ...
PONYPROG_CONDITIONAL_BUILD(MSVC gendef)
# 
OPTION(PONYPROG_ENABLE_DISTRIBUTION "Enable distribution targets." ON)
PONYPROG_CONDITIONAL_BUILD(PONYPROG_ENABLE_DISTRIBUTION distribution)

# Hide some cruft ...
MARK_AS_ADVANCED(CMAKE_BACKWARDS_COMPATIBILITY)
MARK_AS_ADVANCED(CMAKE_EXECUTABLE_FORMAT)
MARK_AS_ADVANCED(CMAKE_LIBRARY_OUTPUT_DIRECTORY)
MARK_AS_ADVANCED(CMAKE_OSX_ARCHITECTURES)
MARK_AS_ADVANCED(CMAKE_OSX_DEPLOYMENT_TARGET)
MARK_AS_ADVANCED(CMAKE_OSX_SYSROOT)
MARK_AS_ADVANCED(CMAKE_RUNTIME_OUTPUT_DIRECTORY)
MARK_AS_ADVANCED(CMAKE_USE_CHRPATH)

=== SrcPony/CMakeLists.txt ===
#CMakeLists.txt

SET(PONY_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/aboutmdlg.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/main.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/Translator.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/e2app.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/at25xxx.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/at93cbus.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/crc.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/e24xx-1.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/e24xx-2.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/e24xx.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/e24xx-5.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/e2profil.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/fusemdlg.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/bitfield.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/blockmdlg.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/intfbuf.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/lpt_io_interf.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/pgminter.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/picbus.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/progoption.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/sernumdlg.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/x2444.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/at17xxx.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/at89sbus.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/at93cxx8.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/csmfbuf.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/e2cmdw.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/e2awinfo.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/easyi2c_interf.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/i2cbus.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/ispinterf.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/microbus.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/pic125xx.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/picbusnew.cpp
#                  ${CMAKE_CURRENT_SOURCE_DIR}/retrymdlg.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/spi-bus.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/at250bus2.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/at89sxx.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/at93cxx.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/device.cpp
#                  ${CMAKE_CURRENT_SOURCE_DIR}/e2cnv.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/eeptypes.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/imbus.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/linuxsysfsint.cpp
#                  ${CMAKE_CURRENT_SOURCE_DIR}/modaldlg_utilities.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/pic12bus.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/ponyioint.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/rs232int.cpp
#                  ${CMAKE_CURRENT_SOURCE_DIR}/sxbus.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/at250bus.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/at90sbus.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/binfbuf.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/dt006interf.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/e2dlg.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/filebuf.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/infomdlg.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/lpt_ext_interf.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/motsfbuf.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/pic168xx.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/portint.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/sde2506.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/wait.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/at250xx.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/at90sxx.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/busio.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/e2401.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/e2pfbuf.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/filldlg.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/interfconv.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/lptinterf.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/nvm3060.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/pic16xx.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/x2444bus.cpp
#                  ${CMAKE_CURRENT_SOURCE_DIR}/profile.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/sdebus.cpp)


                 
SET(PONY_NOMOC_HEADERS 
                 ${CMAKE_CURRENT_SOURCE_DIR}/e2app.h 
                 ${CMAKE_CURRENT_SOURCE_DIR}/e2awinfo.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/Translator.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/globals.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/device.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/microbus.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/at25xxx.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/at93cbus.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/busio.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/dt006interf.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/e24xx.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/eeptypes.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/ispinterf.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/lpt_io_interf.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/pgminter.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/picbus.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/sde2506.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/at17xxx.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/at89sbus.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/at93cxx8.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/e2401.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/e2pfbuf.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/errcode.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/i2cbus.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/jdminter.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/pic125xx.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/picbusnew.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/sdebus.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/types.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/at250bus2.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/at89sxx.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/at93cxx.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/crc.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/e24xx-1.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/e2phead.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/filebuf.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/imbus.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/linuxsysfsint.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/pic12bus.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/ponyioint.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/resource.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/wait.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/at250bus.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/at90sbus.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/binfbuf.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/csmfbuf.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/e24xx-2.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/e2profil.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/lpt_ext_interf.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/motsfbuf.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/pic168xx.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/portint.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/spi-bus.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/x2444bus.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/at250xx.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/at90sxx.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/businter.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/e24xx-5.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/easyi2c_interf.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/intfbuf.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/lptinterf.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/nvm3060.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/pic16xx.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/ppuser.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/rs232int.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/x2444.h)
                 
                 
SET(PONY_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/fusemdlg.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/bitfield.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/filldlg.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/blockmdlg.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/e2cmdw.h 
                 ${CMAKE_CURRENT_SOURCE_DIR}/e2dlg.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/aboutmdlg.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/progoption.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/sernumdlg.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/infomdlg.h)


SET(PONY_FORMS  ${CMAKE_CURRENT_SOURCE_DIR}/forms/aboutdlg.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/editdlg.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/bitfield.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/notesdlg.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/e2dlg.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/fusedlg.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/mainwindow.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/osccalibr.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/progoption.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/sernumcfg.ui
                PARENT_SCOPE)

                
SET(PONY_SOURCES ${PONY_SOURCES}
		PARENT_SCOPE)
		
SET(PONY_NOMOC_HEADERS ${PONY_NOMOC_HEADERS}
		PARENT_SCOPE)

SET(PONY_HEADERS ${PONY_HEADERS}
		PARENT_SCOPE)
		
# SET(FILES_TO_TRANSLATE ${FILES_TO_TRANSLATE} ${MAIN_SOURCES} ${MAIN_FORMS} ${MAIN_HEADERS} 
#                  PARENT_SCOPE)

		 
SET(APP_RESOURCES  ${CMAKE_CURRENT_SOURCE_DIR}/ponyprog.qrc
		 PARENT_SCOPE)


# cleanup $build/*.cpp~ on "make clean"
SET_DIRECTORY_PROPERTIES(PROPERTIES
    ADDITIONAL_MAKE_CLEAN_FILES "${CMAKE_CURRENT_SOURCE_DIR}/*~")

=== distribution/CMakeLists.txt ===
# Setup automatic generation of the changelog
MESSAGE(STATUS "Generate installation variables..." )
ADD_CUSTOM_TARGET(changelog
	COMMAND ${HGCOMMAND} log > ${PONYPROG_BINARY_DIR}/ChangeLog
	WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
	)


SET( CPACK_SOURCE_PACKAGE_FILE_NAME "ponyprog-${APP_VERSION}" )



# --- Package generation
# SET( CPACK_BUILD_CONFIG "Release_and_Debug" )
# SET( CPACK_PACKAGE_NAME ${CMAKE_PROJECT_NAME})
SET( CPACK_PACKAGE_VENDOR "Lancos" )
SET( CPACK_PACKAGE_INSTALL_DIRECTORY "PONYPROG ${APP_VERSION}" )
SET( CPACK_PACKAGE_INSTALL_REGISTRY_KEY "PONYPROG ${APP_VERSION}" )
SET( CPACK_PACKAGE_HOMEPAGE "http://ponyprog.sourceforge.net/" )


# Setup global packaging parameters ...
SET( PONYPROG_CPACK_INSTALL_CMAKE_PROJECTS "${CURRENT_BUILD_DIR};ponyprog;ALL;/" )
# MESSAGE("PONYPROG_BINARY_DIR ${CURRENT_BUILD_DIR}")
# SET( PONYPROG_CPACK_PACKAGE_DESCRIPTION "Ponyprog free GUI for EEPROM and microcontroller flashing." )
SET( PONYPROG_CPACK_PACKAGE_FILE_NAME "ponyprog-setup-${APP_VERSION}" )
SET( PONYPROG_CPACK_PACKAGE_VERSION "${APP_VERSION}" )
SET( PONYPROG_CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/LICENSE" )

SET( PONYPROG_CPACK_SOURCE_INSTALLED_DIRECTORIES "${PROJECT_SOURCE_DIR};/" )
SET( PONYPROG_CPACK_SOURCE_PACKAGE_FILE_NAME "ponyprog-source-${APP_VERSION}" )
SET( PONYPROG_CPACK_SOURCE_IGNORE_FILES
    "/\\\\.svn/"
    "/\\\\.kdev4/*"
    "/\\\\.git/*"
    "/pics/"
    "/build*/*"
    "\\\\.deb"
    "\\\\.rpm"
    "\\\\.zip"
    "\\\\.kdev4"
    "/cppreport"
    "/ponyprog$"
#     "~$"
#     "/ponyprog"
#     "TODO.txt"
#     "CMakeLists.txt.user"
#     "/doxygen/"
#     "${CMAKE_BINARY_DIR}"
)

SET( PONYPROG_CPACK_PACKAGE_NAME ${CMAKE_PROJECT_NAME} )
# SET( PONYPROG_CPACK_PACKAGE_VERSION ${APP_VERSION} )
SET( PONYPROG_CPACK_PACKAGE_RELEASE 0 )
SET( PONYPROG_CPACK_PACKAGE_MAINTAINER "${APP_AUTHOR} <${APP_EMAIL}>" )
SET( PONYPROG_CPACK_PACKAGE_MAINTAINER_NAME "${APP_AUTHOR}" )
SET( PONYPROG_CPACK_PACKAGE_MAINTAINER_EMAIL "${APP_EMAIL}" )
SET( PONYPROG_CPACK_PACKAGE_DESCRIPTION "EEPROM and microcontroller flasher" )
SET( PONYPROG_CPACK_PACKAGE_DESCRIPTION_SUMMARY "EEPROM and microcontroller flasher for PIC, Atmega and other chips" )
# SET( PACKAGE_DEPENDS ${hugr_dependencies} )

SET( PONYPROG_CPACK_PACKAGE_DEPENDS "${PONYPROG_CPACK_PACKAGE_SHLIBDEPS}" )

#SET( PONYPROG_CPACK_PACKAGE_DEPENDS "libhttrack2, libqtcore4, libqtgui4, libc6, libstdc++6" )
# SET( PONYPROG_CPACK_PACKAGE_DEPENDS "libhttrack2, libqtcore4, libqtgui4" )
# SET( PACKAGE_DEPENDS "libc6 (>= 2.1.3), libhttrack (>= 3.42.1), libqtcore4 (>= 4:4.6.1), libqtgui4 (>= 4:4.5.3), libstdc++6 (>= 4.1.1)" )


# SET( PONYPROG_CPACK_PACKAGE_GROUP "Groupe" )
SET( PONYPROG_CPACK_PACKAGE_LICENSE "GPL2" )

# ADD_CUSTOM_TARGET(changelog
# 	COMMAND ${GITCOMMAND} log > ${PONYPROG_BINARY_DIR}/ChangeLog
# 	WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
# 	)

# Setup convenience targets for tagging and branching
# SET( PONYPROG_VERSION_TAG "ponyprog-${PONYPROG_MAJOR_VERSION}.${PONYPROG_MINOR_VERSION}.${PONYPROG_RELEASE_VERSION}.${PONYPROG_BUILD_VERSION}" )
# SET( PONYPROG_VERSION_TAG "ponyprog-${PONYPROG_VERSION}" )
# ADD_CUSTOM_TARGET(tag-version
# 	COMMAND ${GITCOMMAND} tag ${PONYPROG_VERSION_TAG}
# 	WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
# 	)

#SET( PONYPROG_BRANCH_TAG "ponyprog-release-${PONYPROG_MAJOR_VERSION}.${PONYPROG_MINOR_VERSION}" )
#ADD_CUSTOM_TARGET(tag-branch
#	COMMAND ${SVNCOMMAND} cp ${PONYPROG_SVN_TRUNK}
#	${PONYPROG_SVN_BRANCHES}/${PONYPROG_BRANCH_TAG} -m "COMP: Branched PONYPROG Version ${PONYPROG_MAJOR_VERSION}.${PONYPROG_MINOR_VERSION}"
#	WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
#	)
# MESSAGE("CMAKE_CURRENT_SOURCE_DIR distr ${CMAKE_CURRENT_SOURCE_DIR} : ${PROJECT_SOURCE_DIR}")
# Get a SourceForge username so we can upload distributables to the FRS
# IF(WIN32)
# 	SET( PONYPROG_SOURCEFORGE_USERNAME "$ENV{USERNAME}" CACHE STRING "SourceForge user account name, for uploading distribution files." )
# ELSE(WIN32)
# 	SET( PONYPROG_SOURCEFORGE_USERNAME "$ENV{USER}" CACHE STRING "SourceForge user account name, for uploading distribution files." )
# ENDIF(WIN32)
# MARK_AS_ADVANCED(PONYPROG_SOURCEFORGE_USERNAME)



# Setup some macros that can be used by the platform-specific distribution logic
MACRO(PONYPROG_CHECK_INSTALLED_VERSION FOUND PACKAGE EXPECTED)
	IF(NOT ${FOUND} STREQUAL ${EXPECTED})
		MESSAGE(SEND_ERROR "Found ${PACKAGE} version ${FOUND} - for installation, version ${EXPECTED} is required." )
	ENDIF(NOT ${FOUND} STREQUAL ${EXPECTED})
ENDMACRO(PONYPROG_CHECK_INSTALLED_VERSION)

# IF(UNIX AND NOT APPLE)
#     SET(CPACK_STRIP_FILES TRUE)
# 
#     SET(CPACK_SET_DESTDIR "ON")
#     SET(CPACK_INSTALL_PREFIX "/usr") 
#     SET(CPACK_PACKAGE_INSTALL_DIRECTORY "/usr")
# ENDIF(UNIX AND NOT APPLE)

# Generate source packages
ADD_SUBDIRECTORY(source)

# Generate platform-specific binary packages
IF(APPLE)
	ADD_SUBDIRECTORY(osx)
ENDIF(APPLE)

IF(UNIX AND NOT APPLE)
	ADD_SUBDIRECTORY(posix)
ENDIF(UNIX AND NOT APPLE)

IF(WIN32)
	ADD_SUBDIRECTORY(win32)
ENDIF(WIN32)


# INCLUDE(CPack)

=== distribution/posix/CMakeLists.txt ===
SET(CPACK_STRIP_FILES TRUE)

SET(CPACK_SET_DESTDIR "ON")

SET(CPACK_INSTALL_PREFIX "/usr") 
SET(CPACK_PACKAGE_INSTALL_DIRECTORY "/usr")

INCLUDE(GNUInstallDirs)

MESSAGE("CMAKE_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX}")

# SET( CPACK_PACKAGE_GROUP "${PONYPROG_CPACK_PACKAGE_GROUP}" )
SET( CPACK_PACKAGE_LICENSE "${PONYPROG_CPACK_PACKAGE_LICENSE}" )
SET( CPACK_PACKAGE_SHLIBDEPS "${PONYPROG_CPACK_PACKAGE_SHLIBDEPS}" )
# SET( CPACK_PACKAGE_DEPENDS "${PONYPROG_CPACK_PACKAGE_DEPENDS}" )

INSTALL(PROGRAMS "${CURRENT_BUILD_DIR}/ponyprog"
        DESTINATION "${CMAKE_INSTALL_BINDIR}"
        COMPONENT "application"
        PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ
        )

INSTALL(DIRECTORY "${PROJECT_SOURCE_DIR}/icons/"
        DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons"
        COMPONENT "application"
        DIRECTORY_PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ
        FILES_MATCHING PATTERN "*.png"
        )

INSTALL(DIRECTORY "${PROJECT_SOURCE_DIR}/lang/"
        DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/ponyprog/lang/"
        COMPONENT "lang files"
        DIRECTORY_PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ
        FILES_MATCHING PATTERN "*.utf"
        )

INSTALL(DIRECTORY "${PROJECT_SOURCE_DIR}/distribution/innosetup/"
        DESTINATION "${CMAKE_INSTALL_DOCDIR}"
        COMPONENT "help files" 
        DIRECTORY_PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ
        FILES_MATCHING PATTERN "*.jpg" PATTERN "*.html"
        )

INSTALL(FILES "${PROJECT_SOURCE_DIR}/copyright"
        DESTINATION "${CMAKE_INSTALL_DOCDIR}"
        COMPONENT "application"
        PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ
        ) 
# MESSAGE("PROJECT_SOURCE_DIR ${PROJECT_SOURCE_DIR}")

INSTALL(FILES "${PROJECT_SOURCE_DIR}/desktop/ponyprog.desktop"
        DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/applications/"
        COMPONENT "application"
        PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ
        )

SET(CPACK_INSTALL_CMAKE_PROJECTS "${PONYPROG_CPACK_INSTALL_CMAKE_PROJECTS}")

SET(PONYPROG_PACKAGE_DIRECTORY "${CURRENT_BUILD_DIR}")

SET( CPACK_PACKAGE_VENDOR "Lancos" )
# FILE(MAKE_DIRECTORY "${PONYPROG_PACKAGE_DIRECTORY}")
# MESSAGE("CMAKE_CURRENT_SOURCE_DIR posix ${CMAKE_CURRENT_SOURCE_DIR}")
# MESSAGE("DIR: ${CMAKE_CURRENT_SOURCE_DIR}")

SET(CPACK_COMPONENTS_ALL "application" "lang files" "help files")
SET(CPACK_COMPONENTS_INSTALL "ON")

# if not defined
IF(NOT DEBIAN_ARCHITECTURE)
    execute_process(
      COMMAND dpkg --print-architecture
      OUTPUT_VARIABLE DEBIAN_ARCHITECTURE
      OUTPUT_STRIP_TRAILING_WHITESPACE
    )
  #SET(DEBIAN_ARCHITECTURE i386) #dpkg --print-architecture is always i386 on intel
ENDIF(NOT DEBIAN_ARCHITECTURE)

IF(DEBIAN_ARCHITECTURE)
    MESSAGE("DEBIAN_ARCHITECTURE ${DEBIAN_ARCHITECTURE}")
    SET( PONYPROG_CPACK_PACKAGE_FILE_NAME "ponyprog-${APP_VERSION}-${DEBIAN_ARCHITECTURE}" )
    SET(DEBIAN_POSTINST postinst.in)
    
    CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-binary-deb.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-binary-deb.cpack)
    CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/${DEBIAN_POSTINST} ${CMAKE_CURRENT_BINARY_DIR}/packaging/debian-control/postinst)
    ADD_CUSTOM_TARGET(package-binary-deb
        WORKING_DIRECTORY "${PONYPROG_PACKAGE_DIRECTORY}"
        COMMAND ${CMAKE_CPACK_COMMAND} --config ${CMAKE_CURRENT_BINARY_DIR}/package-binary-deb.cpack
        )
ENDIF()

IF(NOT DEBIAN_ARCHITECTURE)
    FIND_PROGRAM(RPMBUILD
        NAMES rpmbuild
        PATHS "/usr/bin")

    IF ( RPMBUILD )
        GET_FILENAME_COMPONENT(RPMBUILD_PATH ${RPMBUILD} ABSOLUTE)
        MESSAGE(STATUS "Found rpmbuild : ${RPMBUILD_PATH}")
        SET(RPMBUILD_FOUND "YES")
        execute_process(
           COMMAND arch
           OUTPUT_VARIABLE RPM_ARCHITECTURE
           OUTPUT_STRIP_TRAILING_WHITESPACE
        )
    ENDIF ( RPMBUILD )
ENDIF()

IF(RPM_ARCHITECTURE)
    MESSAGE("RPM_ARCHITECTURE ${RPM_ARCHITECTURE}")
    SET( PONYPROG_CPACK_PACKAGE_FILE_NAME "ponyprog-${APP_VERSION}-${RPM_ARCHITECTURE}" )
    SET( RPM_POSTINST postinst.in)
    
    CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-binary-rpm.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-binary-rpm.cpack)
    CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/${RPM_POSTINST} ${CMAKE_CURRENT_BINARY_DIR}/packaging/rpm-script/postinst.sh)
    
    ADD_CUSTOM_TARGET(package-binary-rpm
        WORKING_DIRECTORY "${PONYPROG_PACKAGE_DIRECTORY}"
        COMMAND ${CMAKE_CPACK_COMMAND} --config ${CMAKE_CURRENT_BINARY_DIR}/package-binary-rpm.cpack
        )
ENDIF()

# Generate self-extracting tarballs
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-binary-stgz.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-binary-stgz.cpack)
ADD_CUSTOM_TARGET(package-binary-stgz
        WORKING_DIRECTORY "${PONYPROG_PACKAGE_DIRECTORY}"
        COMMAND ${CMAKE_CPACK_COMMAND} --config ${CMAKE_CURRENT_BINARY_DIR}/package-binary-stgz.cpack
        )

# Generate tarballs
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-binary-tbz2.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-binary-tbz2.cpack)
ADD_CUSTOM_TARGET(package-binary-tbz2
        WORKING_DIRECTORY "${PONYPROG_PACKAGE_DIRECTORY}"
        COMMAND ${CMAKE_CPACK_COMMAND} --config ${CMAKE_CURRENT_BINARY_DIR}/package-binary-tbz2.cpack
        )

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-binary-tgz.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-binary-tgz.cpack)
ADD_CUSTOM_TARGET(package-binary-tgz
        WORKING_DIRECTORY "${PONYPROG_PACKAGE_DIRECTORY}"
        COMMAND ${CMAKE_CPACK_COMMAND} --config ${CMAKE_CURRENT_BINARY_DIR}/package-binary-tgz.cpack
        )

# Note ... we intentionally don't provide upload capability for Posix packages, and leave distribution to the experts

# INCLUDE(CPack)

=== debian/changelog ===
ponyprog (3.0.2+ds-1) unstable; urgency=medium

  * [173f002] New upstream version 3.0.2+ds
  * [d436547] drop patch queue
    The patches are applied by usptream.
  * [52e360d] d/control: add graphicsmagick-imagemagick-compat to B-D
    To use the helper tool 'convert' we need a new Build-Depends on this
    package.
  * [a453aba] d/rules: create and install app icons on our own
    Upstream is shipping a SVG graphic and we can create the required PNG files
    by ourself while building the package.
  * [db03d90] d/ponyprog.install: also install the ponyprog SVG file
  * [b45d629] d/rules: improve dh_clean behaviour
    Tweak the dh_clean target by overriding and adding some extra stuff so
    the build can be started multiple times within the same chroot.

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sat, 09 Feb 2019 20:24:41 +0100

ponyprog (3.0.0~rc0+ds-1) unstable; urgency=medium

  * Initial Packaging (Closes: #920199)

 -- Carsten Schoenert <c.schoenert@t-online.de>  Tue, 22 Jan 2019 19:42:00 +0100

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_HOST_ARCH_OS   ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

ICON_SIZES=128x128 64x64 48x48 32x32 24x24 16x16

# out of tree build folder for application
DEB_BUILD_DIR=debian/build
# default install folder
INSTDIR=$(CURDIR)/debian/tmp

DEB_PONYPROG_CMAKE_OPTS := \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
	-DUSE_DEBUGGER=ON \
	-DUSE_QT5=ON \
	$(NULL)

%:
	dh $@

override_dh_auto_clean:
	dh_clean
	rm -f SrcPony/version.h
	rm -rf debian/build

override_dh_auto_configure:
	mkdir -p $(DEB_BUILD_DIR)
	####################################
	# configuring PonyProg application #
	####################################
	dh_auto_configure --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR) -- $(DEB_PONYPROG_CMAKE_OPTS)

override_dh_auto_build:
	dh_auto_build --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)

override_dh_auto_install:
	###################################
	# installing PonyProg application #
	###################################
	dh_auto_install --destdir=$(INSTDIR) --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)
	# remove the shipped icon and create the needed graphic by ourself
	rm -f $(INSTDIR)/usr/share/icons/ponyprog.png
	for size in ${ICON_SIZES}; do \
		mkdir -p $(INSTDIR)/usr/share/icons/hicolor/"$${size}"; \
		convert +antialias -background transparent -resize "$${size}!" $(CURDIR)/icons/ponyprog.svg $(INSTDIR)/usr/share/icons/hicolor/"$${size}"/ponyprog.png; \
	done

=== debian/watch ===
# See uscan(1) for format

# Compulsory line, this is a version 4 file
version=4
#opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/<project>-$1\.tar\.gz/ \
# https://github.com/lancos/ponyprog/releases .*/?(\d\.\d.\d)\.tar\.gz

opts="mode=git, uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\.?\d*)$/$1~$2/, \
  dversionmangle=s/\+ds(\.?\d+)?$//" \
  https://github.com/lancos/ponyprog.git \
  refs/tags/(\d+\.\d+\.\d+(?:\.?beta[1-9])?)

## ponyprog 3.1.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -43,8 +43,10 @@
 
 
 IF(${USE_DEBUGGER})
+  SET(CMAKE_BUILD_TYPE Debug)
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS_DEBUG} -Wall")
 ELSE()
+  SET(CMAKE_BUILD_TYPE Release)
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS_RELEASE} -Wall")
 ENDIF()
 
@@ -72,6 +74,15 @@
 
 
 SET(CURRENT_BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR})
+
+INCLUDE(FindLibUSB-1.0)
+
+
+IF(NOT ${LIBUSB_VERSION} LESS "1.0.16")
+  MESSAGE(STATUS "LibUSB version ${LIBUSB_VERSION}")
+ELSE()
+  MESSAGE(FATAL_ERROR "-- LibUSB version ${LIBUSB_VERSION} TOO OLD! Please Install this library newer as 1.0.16")
+ENDIF()
 
 
 # Set the PonyProg version
@@ -118,9 +129,9 @@
 # ENDIF(MSVC)
 
 IF (CMAKE_COMPILER_IS_GNUCC AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.7)
-    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x -fno-exceptions -fno-rtti")
-ELSE()
-    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fno-exceptions -fno-rtti")
+    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x -fno-exceptions")
+ELSE()
+    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fno-exceptions")
 ENDIF()
 
 
@@ -167,14 +178,24 @@
     ENDIF(NOT Qt5Multimedia_FOUND)
 ENDIF()
 
+#set ( FTDIPP ON )
+FIND_PACKAGE ( LibFTDI1 NO_MODULE REQUIRED )
+
+IF(NOT LibFTDI1_FOUND)
+    MESSAGE(FATAL_ERROR "LibFTDI1 files are not found. "
+    "LibFTDI1 and LibFTDIPP1 development packages are to install.")
+ENDIF(NOT LibFTDI1_FOUND)
+
+INCLUDE ( ${LIBFTDI_USE_FILE} )
+
 # for this feature install debhelper or 
 SET(PONYPROG_CPACK_PACKAGE_SHLIBDEPS ON)
 
 IF(${USE_QT_VERSION} MATCHES "4")
-    INCLUDE_DIRECTORIES(${QT_INCLUDES})
+    INCLUDE_DIRECTORIES(${QT_INCLUDES} ${LIBUSB_INCLUDE_DIRS})
     MESSAGE(STATUS "QT_INCLUDES ${QT_INCLUDES}")
 ELSE()
-    INCLUDE_DIRECTORIES(${QT_INCLUDES} ${Qt5Widgets_INCLUDE_DIRS}  ${Qt5PrintSupport_INCLUDE_DIRS} ${Qt5Multimedia_INCLUDE_DIRS})
+    INCLUDE_DIRECTORIES(${QT_INCLUDES} ${Qt5Widgets_INCLUDE_DIRS}  ${Qt5PrintSupport_INCLUDE_DIRS} ${Qt5Multimedia_INCLUDE_DIRS} ${LIBUSB_INCLUDE_DIRS})
 
     MESSAGE(STATUS "QT_INCLUDES ${QT_INCLUDES} ${Qt5Widgets_INCLUDE_DIRS} ${Qt5Multimedia_INCLUDE_DIRS}")
 
@@ -223,19 +244,24 @@
 
 
 IF(NOT ${USE_DEBUGGER})
-    ADD_DEFINITIONS(${QT_DEFINITIONS} -DQT_NO_DEBUG_OUTPUT -DQT_USE_FAST_CONCATENATION -DQT_USE_FAST_OPERATOR_PLUS)
-ENDIF()
+    ADD_DEFINITIONS(${QT_DEFINITIONS} -DQT_NO_DEBUG_OUTPUT -DQT_NO_DEBUG -DQT_USE_FAST_CONCATENATION -DQT_USE_FAST_OPERATOR_PLUS)
+ELSE()
+    ADD_DEFINITIONS(${QT_DEFINITIONS} -DQT_DEBUG)
+ENDIF()
+
 
 IF(${USE_QT_VERSION} MATCHES "4")
     INCLUDE(${QT_USE_FILE})
     ADD_DEFINITIONS(${QT_DEFINITIONS} -DNO_QT3SUPPORT -DDISABLE_QT3SUPPORT -DQT_PROJECT)
 ELSE()
-    ADD_DEFINITIONS( ${Qt5Widgets_DEFINITIONS} ${Qt5PrintSupport_DEFINITIONS} ${Qt5Multimedia_DEFINITIONS} -DQT_PROJECT )
+    ADD_DEFINITIONS(${Qt5Widgets_DEFINITIONS} ${Qt5PrintSupport_DEFINITIONS} ${Qt5Multimedia_DEFINITIONS} -DQT_PROJECT)
 ENDIF()
 
 IF(WIN32)
     ADD_DEFINITIONS(-DUNICODE -D_UNICODE)
 ENDIF()
+
+
 
 ADD_EXECUTABLE(${CMAKE_PROJECT_NAME}
     ${APP_SOURCES} 
@@ -249,11 +275,14 @@
 
 
 IF(${USE_QT_VERSION} MATCHES "4")
-  TARGET_LINK_LIBRARIES(${CMAKE_PROJECT_NAME} ${QT_LIBRARIES} )
-ELSE()
-  TARGET_LINK_LIBRARIES(${CMAKE_PROJECT_NAME} ${QT_LIBRARIES} ${Qt5Widgets_LIBRARIES} ${Qt5Multimedia_LIBRARIES} ${Qt5PrintSupport_LIBRARIES} )
+  TARGET_LINK_LIBRARIES(${CMAKE_PROJECT_NAME} ${QT_LIBRARIES} ${LIBUSB_LIBRARIES})
+ELSE()
+  TARGET_LINK_LIBRARIES(${CMAKE_PROJECT_NAME} ${QT_LIBRARIES} ${Qt5Widgets_LIBRARIES} ${Qt5Multimedia_LIBRARIES} ${Qt5PrintSupport_LIBRARIES} ${LIBUSB_LIBRARIES})
   MESSAGE(STATUS "QT LIBRARIES: ${QT_LIBRARIES} ${Qt5Widgets_LIBRARIES} ${Qt5Multimedia_LIBRARIES} ${Qt5PrintSupport_LIBRARIES} ${Qt5Core_LIBRARIES}")
 ENDIF()
+
+#target_link_libraries(${CMAKE_PROJECT_NAME} ${LIBFTDI_LIBRARIES} )
+target_link_libraries(${CMAKE_PROJECT_NAME} ftdipp1 ${LIBFTDI_LIBRARIES} )
 
 ADD_CUSTOM_TARGET (tags
     COMMAND  ctags -R -f tags ${CMAKE_SOURCE_DIR}/SrcPony
@@ -338,18 +367,3 @@
 ENDMACRO(PONYPROG_COMPILE_RESOURCE)
 
 # Setup subdirectories ...
-PONYPROG_CONDITIONAL_BUILD(MSVC gendef)
-# 
-OPTION(PONYPROG_ENABLE_DISTRIBUTION "Enable distribution targets." ON)
-PONYPROG_CONDITIONAL_BUILD(PONYPROG_ENABLE_DISTRIBUTION distribution)
-
-# Hide some cruft ...
-MARK_AS_ADVANCED(CMAKE_BACKWARDS_COMPATIBILITY)
-MARK_AS_ADVANCED(CMAKE_EXECUTABLE_FORMAT)
-MARK_AS_ADVANCED(CMAKE_LIBRARY_OUTPUT_DIRECTORY)
-MARK_AS_ADVANCED(CMAKE_OSX_ARCHITECTURES)
-MARK_AS_ADVANCED(CMAKE_OSX_DEPLOYMENT_TARGET)
-MARK_AS_ADVANCED(CMAKE_OSX_SYSROOT)
-MARK_AS_ADVANCED(CMAKE_RUNTIME_OUTPUT_DIRECTORY)
-MARK_AS_ADVANCED(CMAKE_USE_CHRPATH)
-

=== distribution/posix/CMakeLists.txt ===
--- 
+++ 
@@ -47,6 +47,12 @@
         PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ
         ) 
 # MESSAGE("PROJECT_SOURCE_DIR ${PROJECT_SOURCE_DIR}")
+
+INSTALL(FILES "${PROJECT_SOURCE_DIR}/udev/rules.d/90-ponyprog.rules"
+        DESTINATION "/lib/udev/rules.d/" 
+        COMPONENT "application" 
+        PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ
+        )
 
 INSTALL(FILES "${PROJECT_SOURCE_DIR}/desktop/ponyprog.desktop"
         DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/applications/"

=== debian/changelog ===
ponyprog (3.1.0+ds-1) unstable; urgency=medium

  * [6196489] d/control: correct VCS entries
    Fixing typos within the VCS links.
  * [c306149] d/watch: fix match regex for version
    Correcting the matching regexp string so uscan can find the tags.
  * [5a19b6d] Update upstream homepage to GitHub resource
    The old used URL for the homepage isn't really helpful, the development is
    happen on the GitHub site of course.
  * [924962a] New upstream version 3.1.0+ds
  * [f340037] d/README.source: update SHA ID for additional tarball
    The source for the additional tarbal is based now on different SHA commit
    id.
  * [846cb3e] d/control: increase Standards-Version to 4.4.1
    No further changes needed.
  * [dcc7607] d/control: update new needed B-D
    The new version requires now new B-D due USB support.
  * [da9fb45] add a patch queue fro a patch-queue branch
    added patch:
    udev-adding-TAG-uaccess-so-users-can-access-the-device.patch
  * [a0a299c] ponyprog.install: install also the udev rule
  * [e04948b] d/watch: remove unneeded old variables

 -- Carsten Schoenert <c.schoenert@t-online.de>  Fri, 08 Nov 2019 21:49:28 +0100

=== debian/control ===
Source: ponyprog
Section: utils
Priority: optional
Maintainer: Debian Electronics Team <pkg-electronics-devel@alioth-lists.debian.net>
Uploaders:
 Carsten Schoenert <c.schoenert@t-online.de>,
Build-Depends:
 cmake,
 debhelper (>= 12~),
 graphicsmagick-imagemagick-compat,
 libftdi1-dev,
 libftdipp1-dev,
 libusb-dev,
 qtbase5-dev,
 qtmultimedia5-dev,
Standards-Version: 4.4.1
Homepage: https://github.com/lancos/ponyprog
Vcs-Browser: https://salsa.debian.org/electronics-team/ponyprog
Vcs-Git: https://salsa.debian.org/electronics-team/ponyprog.git

Package: ponyprog
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Serial device programmer
 PonyProg is a serial device programmer software with a user friendly
 GUI framework available for Windows and Linux. It's purpose is reading
 and writing every serial device. With PonyProg and SI-Prog you can
 program Wafercard for SAT, eeprom within GSM, TV or CAR-RADIO.
 Furthermore it can be used as a low cost starter kit for PIC and AVR.
 .
 Ponyprog supports AVR, SPI eeprom, AVR micro, 12C bus 8bit eeprom, PIC 
 16 micro, PIC 12 micro, AT89S micro and SDE2506 eeprom family chips.
 .
 You can open any HEX, e2p, mot, csm, rom, eep, bin files and burn them
 to uC or PIC. You can even backup the old program on the chip using
 Ponyprog. Ponyprog enables the user to write, verify and erase data on
 the microchip.
 .
 Also setting fuse bits and locks using Ponyprog is possible. You can
 save any HEX file to BIN file or eep file, BIN file to HEX file or MOT
 file and vice versa so you can use Ponyprog as converter too. Ponyprog
 offers serial or parallel port programming for uC's. You can even change
 polarity of control lines without touching the wires using I/O port setup.
 .
 Using Ponyprog together with generic USB2serial adapters is currently
 not possible! There are plans on upstream to use libusb to add such
 functionality.

## ponyprog 3.1.1+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -118,7 +118,7 @@
 # 
 SET(PONYPROG_PACKAGE ponyprog)
 SET(PONYPROG_HOST ${CMAKE_SYSTEM} ${CMAKE_SYSTEM_PROCESSOR})
-SET(PONYPROG_COPYRIGHT "Copyright (c) 1997-2019   ${APP_AUTHOR}, All Rights Reserved.")
+SET(PONYPROG_COPYRIGHT "Copyright (c) 1997-2020   ${APP_AUTHOR}, All Rights Reserved.")
 SET(PONYPROG_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
 
 # Setup high-level build options

=== debian/changelog ===
ponyprog (3.1.1+ds-1) unstable; urgency=medium

  * [95fdf62] New upstream version 3.1.1+ds
  * [ae19605] d/control: increase Standards-Version to 4.5.0
  * [c5b46bd] d/copyright: update copyright years

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sun, 16 Feb 2020 10:17:14 +0100

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
  libusb-dev,
  qtbase5-dev,
  qtmultimedia5-dev,
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Homepage: https://github.com/lancos/ponyprog
 Vcs-Browser: https://salsa.debian.org/electronics-team/ponyprog
 Vcs-Git: https://salsa.debian.org/electronics-team/ponyprog.git
